/*
 *  $Id: mpi_bc.h,v 1.9 1994/01/20 05:57:58 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

/* user include file for MPI programs, with no dependencies */

#ifndef _MPI_INCLUDE_BC
#define _MPI_INCLUDE_BC

/* assorted defined constants */
#include "mpi_errno.h"              /* Error codes */
#define MPI_OK               0      /* Successful function completion */
#define MPI_SUCCESS          MPI_OK /* Successful function completion */
#define MPI_UNDEFINED      (-32766)
#define MPI_UNDEFINED_RANK MPI_UNDEFINED

/* Topology types */
#define MPI_GRAPH  0
#define MPI_CART   1

/* Generic error handling code.  This handles inserting the file and line
   number (in MPI) where the error occured */
#define MPIR_ERROR(comm,code,string) \
    MPIR_Error( comm, code, string, __FILE__, __LINE__ )
    
/* communication modes */
typedef enum { 
    MPI_STANDARD = 0, 
    MPI_READY, 
    MPI_SYNCHRONOUS, 
    MPI_RECV 
} MPI_Mode;

#define MPI_BOTTOM      0

#define MPI_PROCNULL   (-2)

typedef enum {
    MPI_PERSISTENT = 0,
    MPI_EPHEMERAL
} MPI_Persistence;

typedef void *MPI_Buffer;

typedef struct { 
    int count;
    int source;
    int tag;
} MPI_Status;

#endif

