/*
 *  $Id: commreq_free.c,v 1.5 1994/01/31 23:45:39 lusk Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include "mpi.h"
#include "mpisys.h"

/*@
    MPI_Commreq_free - 
@*/
int MPI_Commreq_free( handle )
MPI_Comm_request handle;
{
    if (handle->type == MPIR_SEND)
    {
	MPID_free_send_handle(&((handle)->shandle.dev_shandle));
	SBfree( MPIR_shandles, handle );
    }
    else if (handle->type == MPIR_RECV)
    {
	MPID_free_recv_handle(&((handle)->rhandle.dev_rhandle));
	SBfree( MPIR_rhandles, handle );
    }
    else
	MPIR_error( "MPI_Commreq_free:  bad handle type" );
    return MPI_OK;
}

