/*
 *  $Id: recv.c,v 1.7 1993/12/03 20:46:49 lusk Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: recv.c,v 1.7 1993/12/03 20:46:49 lusk Exp $";
#endif /* lint */

#include "mpi.h"

/*@
    MPI_Recv - Basic receive
@*/
int MPI_Recv( start, count, datatype, source, tag, comm, status )
void             *start;
int              count;
MPI_Datatype     datatype;
int              source;
int              tag;
MPI_Comm comm;
MPI_Status       *status;
{
    MPI_Comm_request handle;

    if (source != MPI_PROCNULL)
    {
	MPI_Irecv(start, count, datatype, source, tag, comm, &handle ); 
	MPI_Wait( &handle, status );
    }
    return MPI_OK;
}
