/*
 *  $Id: get_cartdim.c,v 1.6 1994/02/02 21:30:24 lusk Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Get_cartdim - retrieve cart topology information associated with a 
                  communicator

@*/
int MPI_Get_cartdim ( comm, ndims )
MPI_Comm  comm;
int              *ndims;
{
  /* Check for valid arguments */
  if ( comm == (MPI_Comm)0 ) 
    return (MPI_ERR_COMM_NULL);

  /* Set dims */
  if ( ndims != (int *)0 )
    if ( comm->topology.type == MPI_CART )
      (*ndims) = comm->topology.tag.cart.ndims;
    else
      (*ndims) = MPI_UNDEFINED;

  return (MPI_SUCCESS);
}
